var AimSessionObserver = new Object();

// XXX Global to determine if our onload handler has been called yet.
// For some reason, our onunload handler is getting called before onload
// on the first time we create App.xul. This is a workaround.
var gFirstTime = 1;

AimSessionObserver.OnAssert = function(source, property, target) {
	if (source.EqualsNode(AimSession)) {
		if (property.EqualsNode(SessionState)) {
			var state = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			var signonItem = top.document.getElementById("miSignOn");
			var signoffcloseItem = top.document.getElementById("miSignOffClose");
			var peopleMenu = top.document.getElementById("people_menu");
			var newIMMenu = top.document.getElementById("menu_newIM");
			var importBuddyMenu = top.document.getElementById("miImportBuddyList");
      var exportBuddyMenu = top.document.getElementById("miExportBuddyList");


			if (state == "Register")
			{
				top.title = aimString("app.title.Register");
				signonItem.setAttribute("value", aimString("miSignOn.SignOn"));
				//signonItem.setAttribute("oncommand", "cmdSignOn();");
				signonItem.setAttribute("disabled", "true");
				signoffcloseItem.setAttribute("disabled", "true");
				peopleMenu.setAttribute("disabled", "true");
				newIMMenu.setAttribute("disabled", "true");
				importBuddyMenu.setAttribute("disabled", "true");
        exportBuddyMenu.setAttribute("disabled", "true");
			}
			else if (state == "Offline") {
				top.title = aimString("app.title.SignOn");
				signonItem.setAttribute("value", aimString("miSignOn.SignOn"));
				signonItem.setAttribute("oncommand", "cmdSignOn();");
				signoffcloseItem.setAttribute("disabled", "true");
				signonItem.setAttribute("disabled", "false");
				peopleMenu.setAttribute("disabled", "true");
				newIMMenu.setAttribute("disabled", "true");
				importBuddyMenu.setAttribute("disabled", "true");
        exportBuddyMenu.setAttribute("disabled", "true");
			}
			else if (state == "Online") {
				top.title = aimString("app.title.Online").replace(/%UserName%/, aimSessionCurrentScreenName());
				signonItem.setAttribute("value", aimString("miSignOn.SignOff"));
				signonItem.setAttribute("oncommand", "cmdSignOff();");
				signonItem.setAttribute("disabled", "false");
				signoffcloseItem.setAttribute("disabled", "false");
				peopleMenu.setAttribute("disabled", "false");
				newIMMenu.setAttribute("disabled", "false");
				importBuddyMenu.setAttribute("disabled", "false");
        exportBuddyMenu.setAttribute("disabled", "false");
			}
			else {
				top.title = aimString("app.title.Connecting");
				signonItem.setAttribute("value", aimString("miSignOn.Cancel"));
				signonItem.setAttribute("oncommand", "cmdCancelSignOn();");
				signoffcloseItem.setAttribute("disabled", "true");
				peopleMenu.setAttribute("disabled", "true");
				newIMMenu.setAttribute("disabled", "true");
				importBuddyMenu.setAttribute("disabled", "true");
        exportBuddyMenu.setAttribute("disabled", "true");
			}
		}
	}
};

AimSessionObserver.OnUnassert = function(source, property, target) {};

AimSessionObserver.OnChange = function(source, property, oldTarget, newTarget) {
	AimSessionObserver.OnAssert(source, property, newTarget);
};

AimSessionObserver.OnMove = function(oldSource, newSource, property, target) {
	AimSessionObserver.OnAssert(newSource, property, target);
};

/*
 * Function: AimAppOnWndLoad()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called once app.xul has finished loading. Adds observer 
 * 		AimSessionObserver to the AimDataSource. Initializes the
 *		sidebar.
*/

function AimAppOnWndLoad()
{
	dump("AimAppOnWndLoad()\n");

    // XXX See note at the top of the file
	gFirstTime = 0;

	// Initialize for current online state
	var state = AimDataSource.GetTarget(AimSession, SessionState, true);
	if (state == null)
		state = RDF.GetLiteral("Register");

	AimSessionObserver.OnAssert(AimSession, SessionState, state);
	AimDataSource.AddObserver(AimSessionObserver);

	if ((window.arguments) && (window.arguments[0] == "Setup"))
		AimWindowLoad2(window);
}

/*
 * Function: AimAppOnWndUnload()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called once app.xul has been unloaded. Removes observer 
 * 		AimSessionObserver from the AimDataSource. 
*/

function AimAppOnWndUnload()
{
	dump("AimAppOnWndUnload()\n");
	// XXX See note at the top of the file
	if(gFirstTime == 1)
		return;

	AimDataSource.RemoveObserver(AimSessionObserver);
}

function AimAppOnSidebarTabChange()
{
	dump("OnSidebarTabChange()\n");
}

function AimAppPeopleMenuSwitch(tabValue)
{
	dump("PeopleMenuSwitch()\n");
}

//************  Command Handling ****************

/*
 * Function: cmdNewBrowser()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Function invoked from menu or toolbar to create a new 
 * 		browser window. 
 * 
 * Bugs: URL is hardcoded. Needs to open a user-specified preference.
*/

function cmdNewBrowser()
{
	aimCmdNewBrowser("http://home.netscape.com");
}

/*
 * Function: cmdNewEmail()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Function invoked from menu or toolbar to create a new
 *		messenger window. 
*/

function cmdNewEmail()
{
	aimCmdNewEmail();
}

/*
 * Function: cmdNewIM()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Function invoked from menu or toolbar to create a new IM 
 *		window. Loads the window into a pre-connect state, e.g., the 
 *		dialog consists of screen name field and an editor. This
 *		function determines which buddy is selected in the list. 
 *		If a buddy is selected (the first one found) and is online,
 *		the screenname field in the IM window is initialized to that
 *		buddy. Otherwise, the screen name field is set to "".
*/

function cmdNewIM()
{
	var sidebarframe = top.frames["AppPanel"];
	var selectedGroup = "";
	var wasSelected = false;

	var tree = sidebarframe.document.getElementById("OnlineBuddies");

	// Loop through all the buddies to see which one they want to
	// send an IM to.  If they have not selected anyone, or if they
	// have selected a group, bring up a blank IM send window.

	var groups = aimBuddyTreeFindGroups(tree);
	
	if ( groups ) {		
		for (var i = 0; i != groups.length; i++) 
			{
			if (groups[i].getAttribute("selected") == "true") 
				{
				selectedGroup = groups[i].getAttribute("Name");
				if ( selectedGroup != null && selectedGroup != "" ) 
					{
	
					// a group was selected, so invoke with
					// screen name null

					wasSelected = true;
					aimIMInvokeIMForm(null, null);
					}
				}
			else 
				{

				// find the buddies in the data source that
				// correspond to the current group in the loop

				var buddies = null;
				for (var j = 0; j != groups[i].childNodes.length; j++)
				{
					if (groups[i].childNodes[j].nodeName == "treechildren")
					{
						buddies = groups[i].childNodes[j].childNodes;
						break;
					}
				}

				if (buddies)
				{
					// we found the buddies, now see if we
					// can find a selected one

					for (var k = 0; k != buddies.length; k++)
					{
						if (buddies[k].getAttribute("selected") == "true")
						{
							selectedBuddy = buddies[k].getAttribute("ScreenName");
							if ( selectedBuddy && selectedBuddy != "" ) {
								// found a selected buddy. If there
								// is a window already, display an 
								// error message, else create a new one

								wasSelected = true;
								if ( aimIMDoesIMExist(selectedBuddy) )
									aimErrorBox(aimString("msg.DuplicateIM"));
								else
									aimIMInvokeIMForm(selectedBuddy, null);
								return;
							}					
						}
					}
				}
			}
		}
	}

	// if we get here, nothing was selected in the list, so invoke a 
	// IM form with an empty screen name

	if ( wasSelected == false )
		aimIMInvokeIMForm(null, null);
}

/*
 * Function: cmdLoadBuddyList()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Unimplemented. See bugsplat 361248
*/

function cmdLoadBuddyList()
{
	dump("Implement Menu Command cmdLoadBuddyList()\n");
}

/*
 * Function: cmdSaveBuddyList()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Unimplemented. See bugsplat 361248 
*/

function cmdSaveBuddyList()
{
	dump("Implement Menu Command cmdSaveBuddyList()\n");
}

/*
 * Function: cmdSendFile()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Unimplemented
*/

function cmdSendFile()
{
	dump("Implement Menu Command cmdSendFile()\n");
}

/*
 * Function: cmdGetFile()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Unimplemented
*/

function cmdGetFile()
{
	dump("Implement Menu Command cmdGetFile()\n");
}

/*
 * Function: cmdSignOn()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called from menu item or toolbar. Passes control to sidebar
 *		panel cmdSignOn() (see SidebarPanel/SidebarPanel.js)
*/

function cmdSignOn()
{
	var sidebarframe = top.frames["AppPanel"];
	sidebarframe.cmdSignOn();
}

/*
 * Function: cmdSignOff()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Calls aimSessionLogoff to close current IM session. 
 * 	
 *
*/

function cmdSignOff()
{
	aimSessionLogoff();
}

/*
 * Function: cmdCancelSignOn()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called during connection startup if cancel button is pressed.
 * 		Cancels the IM session by calling cmdSignOff().
 *		
*/

function cmdCancelSignOn()
{
	cmdSignOff();
}

/*
 * Function: cmdClose()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Invoked from close menu item, or from cmdSignOffAndClose(),
 *		below. Causes the app window to be closed.
 *
*/

function cmdClose()
{
   aimCmdClose();
}

/*
 * Function: cmdSignOffAndClose()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called in response to user selecting signoff and close menu
 *		item. Signs off the current IM session and closes the 
 *		standalone window.
*/

function createInstance( progid, iidName )
{
	var iid = eval( "Components.interfaces." + iidName );
    return Components.classes[ progid ].createInstance( iid );
}

function cmdExportBuddyList()
{
	var fileSpec = createInstance( "component://netscape/filespecwithui", "nsIFileSpecWithUI" );
   	var url;	
	try {
		fileSpec.chooseOutputFile(aimString("title.exportbudlist"), 
			"buddy_list.blt", fileSpec.eTextFiles + fileSpec.eAllFiles);
	}
	catch( e ) {
		// no biggie
	}
	if(fileSpec && fileSpec.isValid()) {
		var status;

		status = aimBuddyExportBuddyList(fileSpec);
		if ( status == false )
			aimErrorBox(aimString("msg.exporttryagain"));
		else
			aimErrorBox(aimString("msg.exportsuccess"));
	} else 
		aimErrorBox(aimString("msg.exportfailure"));
}


function cmdImportBuddyList()
{
	var fileSpec = createInstance( "component://netscape/filespecwithui", "nsIFileSpecWithUI" );
   	var url;	
	try {
		fileSpec.chooseInputFile( aimString("title.importbudlist"),
			fileSpec.eAllFiles, 
			aimString("budlist.seamonkeybudlist"), "*.blt");
	}
	catch( e ) {
		// no biggie
	}
	if(fileSpec) {
		if (fileSpec.isValid() && fileSpec.isFile()) {
			var status;
			status = aimBuddyImportBuddyList(fileSpec);
			if ( status == false )
				aimErrorBox(aimString("msg.importtryagain"));
			else
				aimErrorBox(aimString("msg.importsuccess"));
		}
		else
			aimErrorBox(aimString("msg.importfailure"));
	}
	else
		aimErrorBox(aimString("msg.importfailure"));
}

function cmdSignOffAndClose()
{
	cmdSignOff();
	cmdClose();
}

/*
 * Function: cmdAddBuddy()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called in response to menu item of toolbar button in standalone
 *		for adding a buddy to a buddy group. Opens BuddyAddBuddy.xul to
 *		place a dialog that can be used to add a buddy.
 *
 * Bugs:	Needs to support inline editing.
 * 
*/

function cmdAddBuddy()
{
	var sidebarframe = top.frames["AppPanel"];
	var foundOne = false;
	var selectedGroup = "";

	var tree = sidebarframe.document.getElementById("ListSetup");
	var groups = aimBuddyTreeFindGroups( tree );

	if ( !groups || groups.length == 0 ) {
		aimErrorBox(aimString("msg.NoGroups"));
		return;
	}
	openDialog("chrome://aim/content/BuddyAddBuddy.xul", "", 
		"modal=yes,chrome", groups, tree, null);
}

/*
 * Function: cmdAddGroup()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called in response to menu item of toolbar button in standalone
 *		for adding a buddy group. Opens BuddyAddGroup.xul to place a 
 *		dialog that can be used to add a buddy group.
 *
 * Bugs:	Needs to support inline editing.
 * 
*/

function cmdAddGroup()
{
	openDialog("chrome://aim/content/BuddyAddGroup.xul", "", "modal=yes,chrome");
}

/*
 * Function: SelectedGroup()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Constructor function for SelectedGroup objects
 * 		
 *		
*/

function SelectedGroup()
{
	var selected = "false";
	var name = null;
	var selectedBuddies = null;
}

/*
 * Function: SelectedBuddy()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Constructor function for SelectedBuddy objects
 * 		
*/

function SelectedBuddy()
{
	var selected = "false"
	var name = null;
}

/*
 * Function: cmdDelete()
 *
 * Arguments: None
 * 
 * Return: None
 *
 * Description: Called in response to user clicking delete toolbar button or
 *		selecting delete menu item. Deletes all selected groups (and
 *		the buddies they contain) and all selected buddies.
*/

function cmdDelete()
{	
	// Delete all selected groups and or buddies

	var sidebarframe = top.frames["AppPanel"];
	var selectedGroup = "";
	var wasSelected = false;

	var tree = sidebarframe.document.getElementById("ListSetup");
	var tab = sidebarframe.document.getElementById("OnlineOrgTabPanel");

	if (!tab)
		return;
	if (!tree )
		return;

	if ( tab.getAttribute('index') == 0 ) // in the online tab and the user hit delete
		return;

	var groups = aimBuddyTreeFindGroups( tree );
	dump( "Groups is " + groups + "\n" );
	dump("Num groups is " + groups.length + "\n");

	top.selectedGroups = new Array();
		
	for (var i = 0; i != groups.length; i++) {

		// make a record for this group

		top.selectedGroups[i] = new SelectedGroup;
		top.selectedGroups[i].selectedBuddies = new Array();
		top.selectedGroups[i].name = groups[i].getAttribute("Name");
		if (groups[i].getAttribute("selected") == "true") {
			wasSelected = "true";
			top.selectedGroups[i].selected = "true";
		}
		else
			top.selectedGroups[i].selected = "false";

		// find the buddy nodes for this group.

		var buddies = null;
		for (var j = 0; j != groups[i].childNodes.length; j++)
		{
			if (groups[i].childNodes[j].nodeName == "treechildren")
			{
				// found it.

				buddies = groups[i].childNodes[j].childNodes;
				break;
			}
		}

		// if there were buddies, collect info on them

		if (buddies)
		{
			for (var j = 0; j != buddies.length; j++)
			{
				// create a record for this buddy

				top.selectedGroups[i].selectedBuddies[j] = new SelectedBuddy;
				if (buddies[j].getAttribute("selected") == "true") {
					// buddy is selected. Save the name 
					// and set the selected flag to true

					wasSelected = "true";
					top.selectedGroups[i].selectedBuddies[j].name = buddies[j].getAttribute("ScreenName");	
					top.selectedGroups[i].selectedBuddies[j].selected = "true";
				}
				else 
					top.selectedGroups[i].selectedBuddies[j].selected = "false";
			}
		}
	}

	// now we have all we need to know. Delete the selected buddies
	// and the selected groups

	for ( var i = 0; i != top.selectedGroups.length; i++ ) {

		selectedGroup = top.selectedGroups[i].name;
		
		// first the group

		if ( top.selectedGroups[i].selected == "true" ) {
			if ( selectedGroup != null && selectedGroup != "" ) {
				answer = top.confirm(
					aimString("confirm.DeleteGroup").replace(/%GroupName%/, selectedGroup) );
				if ( answer == true )
					aimBuddyRemoveBuddyGroup(selectedGroup);
			}
		}
		else {
			// we didn't delete the group, so see if any buddies
			// in the group need to be deleted.

			for ( var j = 0; j != top.selectedGroups[i].selectedBuddies.length; j++ ) {
				if ( top.selectedGroups[i].selectedBuddies[j].selected == "true" ) {	
					selectedBuddy = top.selectedGroups[i].selectedBuddies[j].name;
					if ( selectedBuddy && selectedBuddy != "" ) {
dump( "Deleting " + selectedBuddy + " from " + selectedGroup + "\n" );

						answer = top.confirm(
							aimString("confirm.DeleteBuddy").replace(/%BuddyName%/, selectedBuddy).replace(/%GroupName%/, selectedGroup) );
						if ( answer == true ) 
							aimBuddyRemoveBuddy(selectedGroup, selectedBuddy);
					}					
				}
			}
		}
	}

	if ( wasSelected == false )
		aimErrorBox( aimString("msg.NothingToDelete") );
}


