/*------------------------------ nsContextMenu ---------------------------------
|   This JavaScript "class" is used to implement the IM standalon's            |
|   content-area context menu.                                                 |
|                                                                              |
|   For usage, see references to this class in contextMenu.xul.                |
|                                                                              |
------------------------------------------------------------------------------*/
// global context menu
//var contextMenu = null;

function nsContextMenu( xulMenu ) {
    this.menu		      = null;
	this.onlineTab        = false;
	this.listSetupTab     = false;

    // Initialize new menu.
    this.initMenu( xulMenu );
}

// Prototype for nsContextMenu "class."
nsContextMenu.prototype = {
    // onDestroy is a no-op at this point.
    onDestroy : function () {
    },

    // Initialize context menu.
    initMenu : function ( popup, event ) {
		dump("XXX Creating contextual menu...\n");
        this.menu = popup;

        // Get contextual info.
        this.setTarget( document.popupNode );
    
        // Initialize (disable/remove) menu items.
        this.initItems();
    },
    initItems : function () {
        this.initOnlineItems();
        this.initListSetupItems();
    },
    initOnlineItems : function () {
        this.showItem( "context-sendIM", this.onlineTab );
        this.showItem( "context-sendChat", this.onlineTab );
    },
    initListSetupItems : function () {
        this.showItem( "context-addBuddy", this.listSetupTab );
        this.showItem( "context-addGroup", this.listSetupTab );
		this.showItem( "context-delete", this.listSetupTab );
    },
    // Set various context menu attributes based on the state of the world.
    setTarget : function ( node ) {
        // Determine if we're in the Online tab or List Setup tab
		var parentState = top.document.getElementById("AimSidebarState");
		if(!parentState)
			return;

		var curTab;
		parentState.getAttribute("AimSidebarTab", curTab);
		if(curTab == "Online")
			{
				dump("In online tab...\n");
				this.onlineTab = true;
				this.listSetupTab  = true;
			}
		else
			{
				dump("In setup tab...\n");
				this.listSetupTab = true;
				this.onlineTab = true;
			}
    },
    // sendIM
    cmdSendIM : function () {
		dump("Context menu call\n");
    },
    // sendChat
    cmdSendChat : function () {
		dump("Context menu call\n");
    },
    // addbuddy
    cmdAddBuddy : function () {
		dump("Context menu call\n");
    },
    // addGroup
    cmdAddGroup : function () {
		dump("Context menu call\n");
    },
	// delete
    cmdDelete : function () {
		dump("Context menu call\n");
    },
    // Utilities
    // Show/hide one item (specified via name or the item element itself).
    showItem : function ( itemOrId, show ) {
        var item = null;
        if ( itemOrId.constructor == String ) {
            // Argument specifies item id.
            item = document.getElementById( itemOrId );
        } else {
            // Argument is the item itself.
            item = itemOrId;
        }
        if ( item ) {
            var styleIn = item.getAttribute( "style" );
            var styleOut = styleIn;
            if ( show ) {
                // Remove style="display:none;".
                styleOut = styleOut.replace( "display:none;", "" );

            } else {
                // Set style="display:none;".
                if ( styleOut.indexOf( "display:none;" ) == -1 ) {
                    // Add style the first time we need to.
                    styleOut += "display:none;";
                }
            }
            // Only set style if it's different.
            if ( styleIn != styleOut ) {
                item.setAttribute( "style", styleOut );
            }
        }
    },
    // Set given attribute of specified context-menu item.  If the
    // value is null, then it removes the attribute (which works
    // nicely for the disabled attribute).
    setItemAttr : function ( id, attr, val ) {
        var elem = document.getElementById( id );
        if ( elem ) {
            if ( val == null ) {
                // null indicates attr should be removed.
                elem.removeAttribute( attr );
            } else {
                // Set attr=val.
                elem.setAttribute( attr, val );
            }
        }
    },
    // Set context menu attribute according to like attribute of another node
    // (such as a broadcaster).
    setItemAttrFromNode : function ( item_id, attr, other_id ) {
        var elem = document.getElementById( other_id );
        if ( elem && elem.getAttribute( attr ) == "true" ) {
            this.setItemAttr( item_id, attr, "true" );
        } else {
            this.setItemAttr( item_id, attr, null );
        }
    }
};