/////////////////////////////////////////////////////////////////////
// These are our hooks into the public mozilla
// header viewing code. This is where we can insert AIM presence 
// information into the message pane.
//////////////////////////////////////////////////////////////////////

var gPrefs = Components.classes["component://netscape/preferences"];
gPrefs = gPrefs.getService();
gPrefs = gPrefs.QueryInterface(Components.interfaces.nsIPref);

// list of emails we did not have a buddy list association with
var emailList = new Array();
var emailNodeList = new Array();
var emailNodeList2 = new Array();

// callback for RequestGroupPresenceByEmailAddress()
var LocateCallback = new Object();

LocateCallback.OnRequestGroupInfoPresenceComplete = function(pArraySize, pEmailList, pScreenNameList, pPresenceList)
{
	//dump("LocateCallback.OnRequestGroupInfoPresenceComplete\n");
 
  for(i in emailNodeList)
  {
    if(pPresenceList[i])
    {
      var emailNode = emailNodeList[i];
      //dump(pScreenNameList[i] + " is ONLINE\n");

      emailNode.setAttribute("IMScreenName", pScreenNameList[i]);
      emailNode.setAttribute("BuddyStateString", "ActiveOnline");
 
      // this silly align hack is because css isn't noticing the alignment
      // attribute unless I set it to something...then set it back to what
      // I really want...
      emailNode.setAttribute("align", "left");
      emailNode.setAttribute("align", "right");
      emailNode.setAttribute("max-height", "15px");

      if(emailNodeList2[i])
      {
        emailNode = emailNodeList2[i];
        emailNode.setAttribute("IMScreenName", pScreenNameList[i]);
        emailNode.setAttribute("BuddyStateString", "ActiveOnline");
 
        // this silly align hack is because css isn't noticing the alignment
        // attribute unless I set it to something...then set it back to what
        // I really want...
        emailNode.setAttribute("align", "left");
        emailNode.setAttribute("align", "right");
        emailNode.setAttribute("max-height", "15px");
      }
    }
  }
  emailList.length = 0;
  emailNodeList.length = 0;
  emailNodeList2.length = 0;
}

LocateCallback.OnRequestGroupInfoPresenceError = function(pErrMsg) 
{
	//dump("LocateCallback.OnRequestGroupInfoPresenceError\n");
  emailList.length = 0;
  emailNodeList.length = 0;
  emailNodeList2.length = 0;
}

/* AddExtraAddressProcessing is called by the msgHdrViewOverlay whenever it encounters
   an email address. This gives us the chance to insert presence information.
   
   It's important to realize that each email address is represented by a borderless
   title button. For presence, we just need to poke the image url associated
   with that title button
*/

function AddExtraAddressProcessing(emailAddress, emailNode)
{
  // take the email Address, figure out if we have an AIM uri for this
  // email address...if we do, create a titled button element and based on
  // the online presence, give that button a class. Add it to our watch list
  // so we can change this dom element later on. And then insert it into the enclosingNode


  if (emailAddress && aimABInfo && aimBuddyInfo)
  {
    if(gPrefs)
    {
      var showPresence = gPrefs.GetBoolPref("aim.mail.presence");
      if(!showPresence)
        return;
    }
    else
      return;

    try 
    {
      var screenName = aimABInfo.GetScreenNameFromEmail(emailAddress);
    }
    catch (ex)
      {}
    if (screenName)
    {
       var rdfResourceForName = aimBuddyInfo.GetUserResource(screenName);
       if (rdfResourceForName)
       {
          var target = AimDataSource.GetTarget(rdfResourceForName, buddyStateString, true);
          if (target)
            SetPresence(emailNode, target);
          domNodes[rdfResourceForName.Value] = emailNode;
       }

       // be sure to set the screen name as an attribute on the node so we can get it later...
       emailNode.setAttribute("IMScreenName", screenName);
    }
    else
    {
      // add this email address to the list that will be processed later with the LocateManager

      var length = emailList.length;
      if(emailList[length-1] == emailAddress && length != 0)
      {
        //emailNodeList[length-1] = emailNode;
        emailNodeList2[length-1] = emailNode;
      }
      else
      {
        emailList[length] = emailAddress;
        emailNodeList[length] = emailNode;
      }
      
      //dump("emailNode list is now" + length + "\n");
      //dump("email address is " + emailAddress + "\n");
    }
  }
}

// This will kick off the group processing of presence for email addresses
function FinishEmailProcessing()
{
  //dump("FinishEmailProcessing()\n");

  if(gPrefs)
  {
    var showPresence = gPrefs.GetBoolPref("aim.mail.presence");
    if(!showPresence)
      return;
  }
  else
    return; 

  try
  { aimLocateManager.RequestGroupPresenceByEmailAddress(LocateCallback, emailList.length, emailList); }
  catch(ex)
  {  
    emailList.length = 0;
    emailNodeList.length = 0;
    emailNodeList2.length = 0;
  }
}

// NotifyClearAddresses --> use to clear any observers on the email
// addresses that maybe in the hdr view overlay. Each time a new
// message is loaded in message pane, we'll call this function...
function NotifyClearAddresses()
{
  domNodes = new Object(); // throw away our knowledge of old data sources..

  //emailList = new Array();
  //emailNodeList = new Array();
  //LocateCallback = new Object();
}
