var IMServiceClass = Components.classes['component://netscape/aim/IMManager'];
var pIIMManager  = IMServiceClass.getService(Components.interfaces.nsIIMManager)

var allEnums = null;

// retrieve the privacy mode enums

function getEnums( myInterface )
{
        var enums = { };
        for ( var i in myInterface ) {
                if ( typeof myInterface[i] == "number" ) {
                        enums[i] = myInterface[i];
                }
        }
        return enums;
}

// grab an instance of nsIAimPrivacy

function aimPrivacyObject()
{
        if(pIIMManager) 
                return pIIMManager.QueryInterface(Components.interfaces.nsIAimPrivacy);
        else
                return null;
}

// onload handler for privacy panel. grab the privacy mode enums, and register
// AssertChanges with prefwindow so we get called on OK presses.

function PrefIMPrivacyOnLoad()
{
        if ( allEnums == null )
        	allEnums = getEnums( Components.interfaces.nsAimPrivacyModes );
//	parent.handle.AddOnOK( AssertChanges );
}

function PrefIMPrivacyOnUnload() 
{
	// nothing for now
}

// grab a screenname from the user.

function PostGetUserDlg( which )
{
	openDialog("chrome://pref/content/pref-IM_getuser.xul", "", 
		"modal=yes,chrome", which);
}

// delete the screenname entered by the user from the allow or deny list.
// "which" indicates which list to purge from

function DeleteFromList( which )
{
        var tree = document.getElementById(which);
	var pIAimPrivacy = aimPrivacyObject();
	var selectedUser;
	if ( tree == undefined || tree == null )
		return;
        var users = tree.childNodes[2].childNodes;
	
        for (var i = 0; i != users.length; i++) {
                if (users[i].getAttribute("selected") == "true") {
                        selectedUser = users[i].getAttribute("Name");
			if ( which == "Allow" ) 
				pIAimPrivacy.AllowListRemove( selectedUser );
			else if ( which == "Deny" ) 
				pIAimPrivacy.DenyListRemove( selectedUser );
                        break;
			pIAimPrivacy.UpdateStorage();
		}
	}
}

// onload handler for the dialog used to get a screenname from the user

function GetUserOnLoad()
{
        doSetOKCancel(GetUserAdd, 0);
	top.addMode = window.arguments[0];
}

// called when OK button is pressed in privacy mode preferences panel. Figure
// out what changed, communicate this to AIM Glue backend

function AssertChanges()
{
	// determine what has changed, then set the privacy mode

	var radio;
	var pIAimPrivacy = aimPrivacyObject();

	if ( pIAimPrivacy == undefined || pIAimPrivacy == null )
		return;

	pIAimPrivacy.UpdateStorage();
 	radio = document.getElementById("aim_privacy_contact_allowallusers"); 
	if ( radio != undefined && radio != null && radio.checked == true ) {
		pIAimPrivacy.PrivacyMode = allEnums.AllowAll;
		return;
	}

 	radio = document.getElementById("aim_privacy_contact_allowbuddylistusers"); 
	if ( radio != undefined && radio != null && radio.checked == true ) {
		pIAimPrivacy.PrivacyMode = allEnums.AllowBuddies;
		return;
	}

 	radio = document.getElementById("aim_privacy_contact_allowonlylist"); 
	if ( radio != undefined && radio != null && radio.checked == true ) {
		pIAimPrivacy.PrivacyMode = allEnums.AllowList;
		return;
	}

 	radio = document.getElementById("aim_privacy_contact_blockallusers"); 
	if ( radio != undefined && radio != null && radio.checked == true ) {
		pIAimPrivacy.PrivacyMode = allEnums.DenyAll;
		return;
	}

 	radio = document.getElementById("aim_privacy_contact_blocklistusers"); 
	if ( radio != undefined && radio != null && radio.checked == true ) {
		pIAimPrivacy.PrivacyMode = allEnums.DenyList;
		return;
	}
}

// Add a user to the allow or deny list. top.addMode defines which list

function GetUserAdd()
{
        var fldUserName = top.document.getElementById("fldUserName");
	var pIAimPrivacy = aimPrivacyObject();
        var name = fldUserName.value;
        if ( name && name != "" ) {
		if ( top.addMode == "Allow" ) {
			pIAimPrivacy.AllowListAdd( name );
		}
		else if ( top.addMode == "Deny" ) {
			pIAimPrivacy.DenyListAdd( name );
		}
		pIAimPrivacy.UpdateStorage();
              	top.window.close();
        }
}

/* 
 * Name: SimpleURI
 *
 * Arguments: URI string, e.g., chrome://foo/bar
 *
 * Description: obtains an instance of nsIURI and sets the spec to the passed
 * uri. Returns the nsIURI instance.
 *
 */

function SimpleURI(s) {
    var clazz = Components.classes["component://netscape/network/standard-url"];
    var iface = Components.interfaces.nsIURI;
    var obj = clazz.createInstance(iface);
    obj.spec = s;
    return obj;
} 

/* 
 * Name: Sound
 *
 * Arguments: none 
 *
 * Description: Creates and returns an instance of nsISound
 *
 */

function Sound() {
    var clazz = Components.classes["component://netscape/sound"];
    var iface = Components.interfaces.nsISound;
    var obj = clazz.createInstance(iface);
    return obj;
}

var pref = null;

/* 
 * Name: GetPrefs
 *
 * Arguments: none 
 *
 * Description: Returns in instance of nsIPref
 *
 */

function GetPrefs()
{
	if ( pref )
		return( pref );
	pref = Components.classes['component://netscape/preferences'];
	if (pref) {
		pref = pref.getService();
	}
	if (pref) {
		pref = pref.QueryInterface(Components.interfaces.nsIPref);
	}
	return( pref );
}

/* 
 * Name: PlaySound
 *
 * Arguments: chrome URI to a sound file
 *
 * Description: Called by onclick handler for speaker titled buttons in
 * the sound preferences panel for IM.
 *
 */

function PlaySound( myURIPref )
{
	var sound = new Sound();
	var myURI;
	var myPref = GetPrefs();

	if ( myPref == null )
		return;
	try {
		myURI = myPref.CopyCharPref( myURIPref );
	}
	catch(e) {
		try {
			myURI = myPref.CopyDefaultCharPref( myURIPref );
		}
		catch(e) {
			return;
		}		
	}		

	var uri = new SimpleURI(myURI);
	if ( sound != undefined && sound != null && uri != undefined && uri != null ) {
		try {
			sound.Play( uri );
		}
		catch( e ) {
			// device may not support sound, so ignore
		}
	}	
}
